#include "runit.h"

#define MAX_MENUS 255

extern struct _SET Set[8];
extern struct _RUNit RUNit;

//for menu
struct MYMENU myMenu[MAX_MENUS];

BOOL MyMenuSetPosition(HWND hwnd, POINT pnt)
{
	int i, num, screenX, screenY;

	for (i=0;i<MAX_MENUS;i++)
	{
		if(myMenu[i].hwnd==hwnd)
			break;
	}
	
	screenX=GetSystemMetrics(SM_CXSCREEN);
	screenY=GetSystemMetrics(SM_CYSCREEN);


	if((pnt.y+myMenu[i].height)>screenY)
		pnt.y=screenY-myMenu[i].height;

	if((pnt.x+myMenu[i].width)>screenX)
	{
		pnt.x=screenX-myMenu[i].width;
		MyMenuMoveOwner(hwnd,i,pnt);
	}

	SetWindowPos(hwnd,HWND_TOPMOST,pnt.x,pnt.y,0,0,SWP_NOSIZE|SWP_NOACTIVATE);


	return 1;
}

BOOL MyMenuMoveOwner(HWND hwnd, int idx, POINT pnt)
{
	HWND hwndOwner;
	RECT rct;
	POINT pntO;

	hwndOwner=GetWindow(hwnd,GW_OWNER);
 	if(hwndOwner)
	{
		GetWindowRect(hwndOwner,&rct);
		pntO.x=pnt.x-(myMenu[idx].width/2);
		pntO.y=rct.top;
		MyMenuMoveOwner(hwndOwner,idx,pntO);
		SetWindowPos(hwndOwner,HWND_TOPMOST,pntO.x,pntO.y,0,0,SWP_NOSIZE|SWP_NOACTIVATE);
	}
}


struct MYMENUITEMS* GetMyMenuItems(HWND hwnd)
{
	int i, num;

	for (i=0;i<MAX_MENUS;i++)
	{
		if(myMenu[i].hwnd==hwnd)
		{
			return &myMenu[i].items;
		}
	}

}

HWND MyMenuGetFirst(void)
{
	return myMenu[0].hwnd;
}

int MyMenuGetWidth(HWND hwnd)
{
	int i;

	for (i=0;i<MAX_MENUS;i++)
	{
		if(myMenu[i].hwnd==hwnd)
		{
			return myMenu[i].width;
		}
	}
	return 0;
}

int MyMenuGetHeight(HWND hwnd)
{
	int i;

	for (i=0;i<MAX_MENUS;i++)
	{
		if(myMenu[i].hwnd==hwnd)
		{
			return myMenu[i].height;
		}
	}
	return 0;
}

int MyMenuGetHiliteFromPoint(HWND hwnd, int y)
{
	struct MYMENUITEMS* items;
	int item=0;
	int i, bot, itemHeight, vSpace;

	vSpace=4;
	bot=0;

	itemHeight=Set[RUNit.iActiveSet].sizBitmap.cy;

	items=GetMyMenuItems(hwnd);

	for(i=0;i<items->iNumTotal;i++)
	{
		if(strcmp(Set[RUNit.iActiveSet].ap[items->item[i]].szAppPat,"SEPARATOR"))
		{
			bot+=itemHeight;
			if(y<bot)
				return i;
		}
		else
		{
			bot+=vSpace;
		}

	}
	return -1;
}

BOOL MyMenuGetRectFromIdx(HWND hwnd,int idx, RECT *rct)
{
	struct MYMENUITEMS* items;
	int item=0;
	int i, bot, itemHeight, vSpace;

	vSpace=4;
	itemHeight=Set[RUNit.iActiveSet].sizBitmap.cy;

	rct->left=0;
	rct->top=0;
	rct->right=	Set[RUNit.iActiveSet].sizBitmap.cx;
	rct->bottom=0;

	bot=0;

	items=GetMyMenuItems(hwnd);

	for(i=0;i<=idx;i++)
	{
		if(strcmp(Set[RUNit.iActiveSet].ap[items->item[i]].szAppPat,"SEPARATOR"))
		{
			rct->top=bot;
			bot+=itemHeight;
			rct->bottom=bot;
		}
		else
		{
			rct->top=bot;
			bot+=vSpace;
			rct->bottom=bot;
		}
	}
	return 1;
}

BOOL MyAddMenu(HWND hwnd,char *szGroupName)
{
	int i, j, itemNum, noSepsNum, itemHeight, itemWidth, vSpace;

	vSpace=4;
	itemWidth=Set[RUNit.iActiveSet].sizBitmap.cx;
	itemHeight=Set[RUNit.iActiveSet].sizBitmap.cy;

	//find a free slot
	for (i=0;i<MAX_MENUS;i++)
	{
		if(myMenu[i].hwnd==0)
		{
			//found a slot
			//set hwnd and name
			myMenu[i].hwnd=hwnd;
			strcpy(myMenu[i].szName,szGroupName);
			myMenu[i].width=itemWidth+GetSystemMetrics(SM_CXDLGFRAME)*2;
			myMenu[i].height=GetSystemMetrics(SM_CXDLGFRAME)*2;
			if(!strlen(myMenu[i].szName))
				myMenu[i].height+=+GetSystemMetrics(SM_CYSMCAPTION);


			//fill items
			itemNum=0;
			noSepsNum=0;
			for (j=0;j<Set[RUNit.iActiveSet].iApps;j++)
			{
				if(!strcmp(Set[RUNit.iActiveSet].ap[j].szGroup,szGroupName))
				{
					myMenu[i].items.item[itemNum]=j;
					itemNum++;
					if(strcmp(Set[RUNit.iActiveSet].ap[j].szAppPat,"SEPARATOR"))
					{
						noSepsNum++;
						myMenu[i].height+=itemHeight;
					}
					else
					{
						myMenu[i].height+=vSpace;
					}
				}
			}

			myMenu[i].items.iNumTotal=itemNum;
			myMenu[i].items.iNum=noSepsNum;
			myMenu[i].iPrevHilite=-1;
			myMenu[i].hwndChild=0;
			return 1;
		}
	}
	return 0;
}

int MyMenuGetPrevHilite(HWND hwnd)
{
	int i;

	for (i=0;i<MAX_MENUS;i++)
	{
		if(myMenu[i].hwnd==hwnd)
		{
			return myMenu[i].iPrevHilite;
		}
	}
	return -1;
}

BOOL MyMenuSetPrevHilite(HWND hwnd,int idx)
{
	int i;

	for (i=0;i<MAX_MENUS;i++)
	{
		if(myMenu[i].hwnd==hwnd)
		{
			myMenu[i].iPrevHilite=idx;
			return 1;
		}
	}
	return 0;
}

HWND MyMenuGetChild(HWND hwnd)
{
	int i;

	for (i=0;i<MAX_MENUS;i++)
	{
		if(myMenu[i].hwnd==hwnd)
		{
			return myMenu[i].hwndChild;
		}
	}
	return 0;
}

BOOL MyMenuSetChild(HWND hwnd, HWND hwndChild)
{
	int i;

	for (i=0;i<MAX_MENUS;i++)
	{
		if(myMenu[i].hwnd==hwnd)
		{
			myMenu[i].hwndChild=hwndChild;
			return 1;
		}
	}
	return 0;
}

char * MyGetMenuGroupName(HWND hwnd)
{
	int i;

	for (i=0;i<MAX_MENUS;i++)
	{
		if(myMenu[i].hwnd==hwnd)
		{
			return myMenu[i].szName;
		}
	}
	return 0;
}

BOOL MyIsWindowRUNit(HWND hwnd)
{
	int i;

	for (i=0;i<MAX_MENUS;i++)
	{
		if(myMenu[i].hwnd==hwnd)
		{
			return 1;
		}
	}
	return 0;
}

BOOL MyDeactivate()
{
	int i;

	for (i=0;i<MAX_MENUS;i++)
	{
		DestroyWindow(myMenu[i].hwnd);
		myMenu[i].hwnd=0;
	}
	return 1;
}

BOOL MyDeleteMenu(HWND hwnd)
{
	int i, num;

	for (i=0;i<MAX_MENUS;i++)
	{
		if(myMenu[i].hwnd==hwnd)
		{
			myMenu[i].hwnd=0;
			MyMenuSetChild(GetWindow(hwnd,GW_OWNER),0);
		}
	}
	return 1;
}

