#include "runit.h"

//round
int round(float num)
{
	return(num+0.5);
}

//displays an error message and the function where it occured
void _error(int iSeverity,char* szText, char* szFunction)
{
	char szMsg[MAX_PATH];

	strcpy(szMsg,"An error occured - ");
	if(iSeverity==FATAL)
		strcat(szMsg,"RUNit will terminate.\n");
	else
		strcat(szMsg,"\n");

	strcat(szMsg,szText);
	strcat(szMsg,"\nin function ");
	strcat(szMsg,szFunction);

	MessageBox(NULL,szMsg,"RUNit",MB_OK|MB_ICONERROR|MB_SETFOREGROUND);
}


// CheckIniFile
// checks if an ini file was specified in the commandline
// and if it is OK
BOOL CheckIniFile(char* lpCmdLine,char* szIni)
{
	DWORD dwError;
	HANDLE hFile;
	char szError[MAX_PATH];

	// is there an cmdline arg? -> default is windows-dir\runit.ini
	if(!strlen(lpCmdLine)){
		GetWindowsDirectory(szIni,MAX_PATH);
		//check for / at the end
		if(szIni[strlen(szIni)]!='\\')
			strcat(szIni,"\\");
		strcat(szIni,"runit.ini");
	}
	else
		strcpy(szIni,lpCmdLine);

	// is the cmdline-arg an existing file or directory?
	if (0xFFFFFFFF==GetFileAttributes(szIni)) //obviously not...
	{	
		dwError=GetLastError();
		if ( (dwError==ERROR_PATH_NOT_FOUND) || (dwError==ERROR_FILE_NOT_FOUND) )
		{
			//can the file be created?
			hFile=CreateFile(szIni,GENERIC_WRITE,0,0,CREATE_NEW,FILE_ATTRIBUTE_NORMAL,0);
			if (hFile==INVALID_HANDLE_VALUE)
			{
				strcpy(szError,"Invalid command line argument!\n\n");
				strcat(szError,"the file  \'");
				strcat(szError,szIni);
				strcat(szError,"'  can not be created.");
				MessageBox(NULL,szError,"RUNit",MB_OK|MB_SETFOREGROUND|MB_ICONERROR);
				return FALSE;
			}
			else
			{
				CloseHandle(hFile);
			}
		}
		else
		{	//another error occured
			MessageBox(NULL,"Invalid command line argument - \'runit.ini\' will be used as default","RUNit",MB_OK);
			strcpy(szIni,"runit.ini");
		}
	}
	else  // it IS an existing file or a directory...
	{ 
		//is it a directory?
		if(GetFileAttributes(szIni)&FILE_ATTRIBUTE_DIRECTORY)
		{
			strcpy(szError,"Invalid command line argument!\n\n \'");
			strcat(szError,szIni);
			strcat(szError,"'  is a directory.");
			MessageBox(NULL,szError,"RUNit",MB_OK|MB_SETFOREGROUND|MB_ICONERROR);
			return FALSE;
		}
		//is it a RUNit ini-file?
		GetPrivateProfileString("0","path","NA",szError,sizeof(szError),szIni);
		if(!strcmp(szError,"NA"))
		{
			GetPrivateProfileString("options","icons","NA",szError,sizeof(szError),szIni);
			if(!strcmp(szError,"NA"))
			{
				strcpy(szError,"The file you have specified does not seem to be a RUNit ini-file:\n\n\'");
				strcat(szError,szIni);
				strcat(szError,"\'");
				MessageBox(NULL,szError,"RUNit",MB_OK|MB_ICONERROR|MB_SETFOREGROUND);
				return FALSE;
			}
		}
	}
	return TRUE;
}


BOOL WriteLog(char *szLogfile,char *szMsg)
{

	HFILE hLogfile;
	DWORD dwBytesWritten;

	hLogfile=CreateFile(szLogfile,GENERIC_WRITE,0,0,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,0);
	SetFilePointer(hLogfile,0,0,FILE_END);
	WriteFile(hLogfile,szMsg,strlen(szMsg),&dwBytesWritten,NULL);
	CloseHandle(hLogfile);
	//SendMessage(FindWindow(NULL,"debugwindow"),WM_SETTEXT,0,(LPARAM)szMsg);
	return TRUE;
}


BOOL CoolFlashWindow(HWND hDlg,HWND hwndFlash)
{
	RECT rct;
	int cx,cy;
	//char sz[129];

	GetWindowRect(hwndFlash,&rct);
	cx=rct.right-rct.left;
	cy=rct.bottom-rct.top;

	MoveWindow(hwndFlash,rct.left-2,rct.top,cx,cy,TRUE);
	MoveWindow(hwndFlash,rct.left,rct.top,cx,cy,TRUE);
	MoveWindow(hwndFlash,rct.left+2,rct.top,cx,cy,TRUE);
	MoveWindow(hwndFlash,rct.left,rct.top,cx,cy,TRUE);
	MoveWindow(hwndFlash,rct.left,rct.top+2,cx,cy,TRUE);
	MoveWindow(hwndFlash,rct.left,rct.top,cx,cy,TRUE);
	MoveWindow(hwndFlash,rct.left,rct.top-2,cx,cy,TRUE);
	MoveWindow(hwndFlash,rct.left,rct.top,cx,cy,TRUE);
	return TRUE;
}

BOOL MakeIniBackup(char *szIni)
{
	char szBackup[MAX_PATH];
	char sz[MAX_PATH];

	_splitpath(szIni,sz,NULL,NULL,NULL);
	strcpy(szBackup,sz);
	_splitpath(szIni,NULL,sz,NULL,NULL);
	strcat(szBackup,sz);
	_splitpath(szIni,NULL,NULL,sz,NULL);
	strcat(szBackup,sz);
	strcat(szBackup,".bak");

	CopyFile(szIni,szBackup,FALSE);
	return TRUE;
}
